/* $Id$ */ 

#ifndef _NSIG
  #ifdef NSIG
  #define _NSIG NSIG
  #else
  #define _NSIG 32
  #endif
#endif

typedef unsigned char byte;
typedef unsigned int u32;
typedef unsigned long long u64;

/* first magic number is used refugee < 0.95 and in later versions if blowfish
   is being used */
#define OLD_BLOWFISH_MAGIC_NUM	0x03
/* next magic num isn't used until refugee 0.95 and indicates that rijndael
 is being used */
#define RIJNDAEL_MAGIC_NUM      0x04
#define BLOWFISH_MAGIC_NUM      0x05

#define REFUGEE_MODE_ECB        0x00
#define REFUGEE_MODE_CBC        0x01

#define KEY_SHA1		0x01
#define KEY_TIGER		0x02
#define KEY_LAME32		0x03
#define KEY_MD5			0x04
#define KEY_RAND448		0x05

    /* the .r file will look like this:
     
        header (152 or 160 bytes)
    	encrypted data (...)
    	thumbprint (40 bytes)
     
     */

typedef struct {
    byte magic;
    byte mode;
    byte random[6];
    u32 fsize;
    u32 fodder1;
    u32 fmode;
    u32 fodder2;
    byte fname[128];
    /* These next 8 bytes don't exist in a blowfish file! */
    byte rijndael_space[8];
} FileHeader;

#define RIJNDAEL_HEADER_SZ 160
#define BLOWFISH_HEADER_SZ 152

typedef struct {
    u32 datalen;
    byte percent;
    byte ver;
    byte fodder[2];
} HIDE_HEADER; 

#define HIDE_HEADER_SZ 8

FILE *fcreate(char *fname);
FILE *frandcreate();
u32 randu32();
void endianswap(byte *b);
u32 *random_key();
u32 lamehash(byte *s);
byte * getbfkey();
void wipe(FILE *f, size_t sz);
void nocore(void);

#ifdef USE_UCRED
int getpeereuid(int s, int *euid);
#endif
