#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include "common.h"
#include "setup.h"
#include "rice4.h"

void make_rice_key(byte *key_data, u32 key_len, RICE4_KEY *key) { /*fold00*/
    int i;

    int d1,d2;

    byte tmp;

    for(i=0;i<256;i++)
        key->S[i] = i;

    key->i = 0;
    key->j = 0;

    d1 = d2 = 0;

    for(i=0;i<256;i++) {
        d2 = (key_data[d1] + key->S[i] + d2) % 256;

        tmp = key->S[i];
        key->S[i] = key->S[d2];
        key->S[d2] = tmp;

        d1 = (d1 + 1) % key_len;
    }
}

void rice4(byte *buf, int len, RICE4_KEY *k) { /*fold00*/
    int i;
    byte tmp;
    byte t;

    for(i=0;i<len;i++) {
        k->i = (k->i + 1) % 256;
        k->j = (k->j + k->S[k->i]) % 256;

        tmp = k->S[k->i];
        k->S[k->i] = k->S[k->j];
        k->S[k->j] =tmp;

        t = (k->S[k->i] + k->S[k->j]) % 256;
        buf[i] ^= k->S[t];
    }
}
